/*
        IcuKrell 0.1.3 - drJeckyll <drJeckyll@hotmail.com>
*/

#include "icukrell.h"

static Panel *panel;
static Decal *decal_text_status, *decal_text_msg_count, *decal_online_users, *decal_pic;
static gchar *message_status = ICU_DOWN;
static gchar *message_msg_count = ICU_NO_MSGS;
static gchar *online_users = NO_USERS;
static gint style_id;

static gint first_start;

static void panel_button_press(GtkWidget *widget, GdkEventButton *ev, gpointer data)
{
	switch (ev->button)
	{
		case 1:
		    if ((ev->type == GDK_2BUTTON_PRESS) && !icukrell_running) start_gnomeicu_func();
		    else
		    {
			if (!strcmp(message_msg_count, ICU_NO_MSGS))
			    do_action("showhide");
			else
			    do_action("readevent");
		    }
		    break;
		case 2:
		    if (icukrell_running) get_online_users(ev);
		    break;
		case 3:
		    options_menu(ev);
		    break;
	}
}

static gint panel_expose_event(GtkWidget *widget, GdkEventExpose *ev)
{
        gdk_draw_pixmap(widget->window, widget->style->fg_gc[GTK_WIDGET_STATE (widget)], panel->pixmap, ev->area.x, ev->area.y, ev->area.x, ev->area.y, ev->area.width, ev->area.height);
        return FALSE;
}

static void update_status_pic()
{
        gint x, y;
        GdkPixmap *pixmap;
        GdkBitmap *mask;

        if (!icukrell_running)
	{
                gkrellm_make_decal_invisible(panel, decal_pic);
		gkrellm_make_decal_invisible(panel, decal_online_users);
		gkrellm_make_decal_invisible(panel, decal_text_msg_count);
	} else
        {
                pixmap = offline_pixmap;
                mask = offline_bitmap;

                if (!strcmp(message_status, ICU_OFFLINE))
                {
                        pixmap = offline_pixmap;
                        mask = offline_bitmap;

			online_users = g_strdup("0");
                }
                if (!strcmp(message_status, ICU_ONLINE))
                {
                        pixmap = online_pixmap;
                        mask = online_bitmap;
                }
                if (!strcmp(message_status, ICU_INVISIBLE))
                {
                        pixmap = inv_pixmap;
                        mask = inv_bitmap;
                }
                if (!strcmp(message_status, ICU_NA) || !strcmp(message_status, ICU_NA_99A))
                {
                        pixmap = na_pixmap;
                        mask = na_bitmap;
                }
                if (!strcmp(message_status, ICU_FREE_CHAT))
                {
                        pixmap = chat_pixmap;
                        mask = chat_bitmap;
                }
                if (!strcmp(message_status, ICU_OCCUPIED) || !strcmp(message_status, ICU_OCCUPIED_MAC))
                {
                        pixmap = occ_pixmap;
                        mask = occ_bitmap;
                }
                if (!strcmp(message_status, ICU_AWAY))
                {
                        pixmap = away_pixmap;
                        mask = away_bitmap;
                }
                if (!strcmp(message_status, ICU_DND))
                {
                        pixmap = dnd_pixmap;
                        mask = dnd_bitmap;
                }

                x = gkrellm_chart_width() - 20;
                y = decal_text_status->y + 3;
                gkrellm_make_decal_invisible(panel, decal_pic);
                decal_pic = gkrellm_create_decal_pixmap(panel, pixmap, mask, 1, NULL, x, y);
                gkrellm_draw_decal_pixmap(panel, decal_pic, 0);
                gkrellm_make_decal_visible(panel, decal_pic);

		if (!strcmp(message_status, ICU_OFFLINE))
		    gkrellm_make_decal_invisible(panel, decal_online_users);
		else
		    gkrellm_make_decal_visible(panel, decal_online_users);
		
		gkrellm_make_decal_visible(panel, decal_text_msg_count);
        }
}

static void update_plugin()
{
        struct sockaddr_un addr;
        gchar new_message_status[100] = ICU_DOWN;
        gchar new_message_msg_count[100];
	gchar new_theme_name[255];
	gchar new_online_users[100];
        gchar *new_message_full;
        unsigned long u;
        gchar *buffer;
        gchar c = 1;
        gint x, y;
        GdkPixmap *pixmap;
        GdkBitmap *mask;
	int socket_fd;

        if ((GK.timer_ticks % 2) == 0)
        {
		sprintf(addr.sun_path, "/tmp/.gnomeicu-%s/ctl", g_get_user_name());

                addr.sun_family = AF_UNIX;
		
                if (!access(addr.sun_path, R_OK) != 0)
                {
                        socket_fd = socket(AF_UNIX, SOCK_STREAM, 0);

                        if(socket_fd >= 0)
                        {
                                if (connect(socket_fd, (struct sockaddr *)&addr, sizeof(addr.sun_family) + strlen(addr.sun_path) + 1) == 0)
                                {
                                        strcpy(new_message_status, "PRB");

                                        buffer = g_malloc0(8192);

                                        strcat(buffer, "icuask");
                                        strcat(buffer, " ");
                                        c = 9;

                                        u = htonl(strlen(buffer) + 1);

                                        write(socket_fd, &c, 1);
                                        write(socket_fd, &u, sizeof(unsigned long));
                                        write(socket_fd, buffer, strlen(buffer)+1);

                                        g_free(buffer);

                                        read(socket_fd, &u, sizeof(unsigned long));
                                        u = g_htonl(u);
                                        if (u < 16384)
                                        {
                                                buffer = g_malloc0(u + 1);
                                                read(socket_fd, buffer, u);

                                                new_message_full = strdup(buffer);
                                                strcpy(new_message_status, strtok(buffer, " "));
                                                strcpy(new_message_msg_count, strtok(NULL, " "));
						sprintf(new_online_users, "%s Users", strtok(NULL, " "));
						strcpy(new_theme_name, strtok(NULL, "\n"));

                                                if (!strcmp(new_message_msg_count, "0"))
                                                        sprintf(new_message_msg_count, "%s", ICU_NO_MSGS);
                                                else
                                                        if (!strcmp(new_message_msg_count, "1"))
								sprintf(new_message_msg_count, "%s", new_message_msg_count);
                                                        else
								sprintf(new_message_msg_count, "%s", new_message_msg_count);

						if (strcmp(new_theme_name, icukrell_theme_name))
						{
							icukrell_theme_name = g_strdup(new_theme_name);
							if (init_pixmaps()) ;
							update_status_pic();
#ifdef TEST_MODE
							fprintf(stderr, "[%s]\n", new_theme_name);
#endif
						}

                                                g_free(buffer);
						
						icukrell_running = TRUE;
                                        }
                                } else icukrell_running = FALSE;
                        }
			close(socket_fd);
                } else icukrell_running = FALSE;

                if (strcmp(message_status, new_message_status))
                {
                        message_status = g_strdup(new_message_status);
			decal_text_status->x_off = 1;
                        gkrellm_draw_text_decal(panel, decal_text_status, message_status, decal_text_status->x_off);
                        decal_text_status->x_off = 0;
                        gkrellm_draw_text_decal(panel, decal_text_status, message_status, decal_text_status->x_off);

                        if (!icukrell_running)
                                gkrellm_make_decal_invisible(panel, decal_text_msg_count);

                        update_status_pic();
                }
		
		if (strcmp(online_users, new_online_users))
		{
			online_users = g_strdup(new_online_users);
			decal_online_users->x_off = 1;
                        gkrellm_draw_text_decal(panel, decal_online_users, online_users, decal_online_users->x_off);
                        decal_online_users->x_off = 0;
                        gkrellm_draw_text_decal(panel, decal_online_users, online_users, decal_online_users->x_off);

                        if (!icukrell_running)
                                gkrellm_make_decal_invisible(panel, decal_online_users);
		}

                if (strcmp(message_msg_count, new_message_msg_count))
                {
			message_msg_count = g_strdup(new_message_msg_count);
			decal_text_msg_count->x_off = 1;
                        gkrellm_draw_text_decal(panel, decal_text_msg_count, message_msg_count, decal_text_msg_count->x_off);
                        decal_text_msg_count->x_off = 0;
                        gkrellm_draw_text_decal(panel, decal_text_msg_count, message_msg_count, decal_text_msg_count->x_off);

                        if (icukrell_running)
                        {
                                if (strcmp(new_message_msg_count, ICU_NO_MSGS))
                                {
                                        pixmap = message_pixmap;
                                        mask = message_bitmap;
                                        x = gkrellm_chart_width() - 20;
                                        y = decal_text_status->y + 3;
                                        gkrellm_make_decal_invisible(panel, decal_pic);
                                        decal_pic = gkrellm_create_decal_pixmap(panel, pixmap, mask, 1, NULL, x, y);
                                        gkrellm_make_decal_visible(panel, decal_pic);
                                        gkrellm_draw_decal_pixmap(panel, decal_pic, 0);
                                } else update_status_pic();
                        }
                }
		
		if (strcmp(message_msg_count, ICU_NO_MSGS) && icukrell_running)
                {
                        if ((GK.timer_ticks % 4) == 0)
			{
                                gkrellm_make_decal_visible(panel, decal_pic);
			} else
			{
                                gkrellm_make_decal_invisible(panel, decal_pic);
			}
				
                }

                gkrellm_draw_layers(panel);
        }
	
	if (first_start && !icukrell_running && icukrell_auto_start)
	{
		start_gnomeicu_func();
		first_start = FALSE;
	}

	if (first_start && icukrell_auto_hide)
	{
		do_action("hide");
		first_start = FALSE;
	}
}

static void create_plugin(GtkWidget *vbox, gint first_create)
{
        Style *style;
        TextStyle *ts, *ts_alt;
        GdkPixmap *pixmap;
        GdkBitmap *mask;
        gint x, y;

#ifdef TEST_MODE
	fprintf(stderr, "start...\n");
#endif
	icukrell_theme_name = "Default";
	first_start = TRUE;

        if (first_create) panel = gkrellm_panel_new0(); else gkrellm_destroy_decal_list(panel);
        style = gkrellm_meter_style(style_id);

        ts = gkrellm_meter_textstyle(style_id);
        ts_alt = gkrellm_meter_alt_textstyle(style_id);
        panel->textstyle = ts;

	if (init_pixmaps()) ;

        decal_text_status = gkrellm_create_decal_text(panel, message_status, ts_alt, style, -1, 4, -1);
        y = decal_text_status->y + decal_text_status->h + 4;
	decal_text_msg_count = gkrellm_create_decal_text(panel, message_msg_count, ts, style, gkrellm_chart_width() - 15, y - 5, 0);
	decal_online_users = gkrellm_create_decal_text(panel, online_users, ts_alt, style, 2, y, 0);

        pixmap = offline_pixmap;
        mask = offline_bitmap;
        x = gkrellm_chart_width() - 20;
        y = decal_text_status->y + 2;
        decal_pic = gkrellm_create_decal_pixmap(panel, pixmap, mask, 1, NULL, x, y);
        gkrellm_configure_panel(panel, NULL, style);
        panel->label->h_panel += 2;
        gkrellm_create_panel(vbox, panel, gkrellm_bg_meter_image(style_id));
        gkrellm_monitor_height_adjust(panel->h);

        gkrellm_draw_decal_text(panel, decal_text_status, message_status, 1);
	gkrellm_draw_decal_text(panel, decal_online_users, online_users, 1);
        gkrellm_make_decal_invisible(panel, decal_text_msg_count);
	gkrellm_make_decal_invisible(panel, decal_online_users);
        gkrellm_draw_decal_pixmap(panel, decal_pic, 0);
        gkrellm_make_decal_invisible(panel, decal_pic);

        if (first_create)
	{
		gtk_signal_connect(GTK_OBJECT (panel->drawing_area), "expose_event", (GtkSignalFunc) panel_expose_event, NULL);
		gtk_signal_connect(GTK_OBJECT (panel->drawing_area), "button_press_event", (GtkSignalFunc) panel_button_press, NULL);
	}
}

void quit_plugin_func()
{
    if (icukrell_auto_hide && icukrell_running)
	do_action("show");
}
      

static Monitor plugin_monitor =
{
        CONFIG_NAME,                    /* Name, for config tab.             */
        0,                              /* Id,  0 if a plugin                */
        create_plugin,                  /* The create function               */
        update_plugin,                  /* The update function               */
        create_icukrell_config,         /* The config tab create function    */
        icukrell_apply_config,          /* Apply the config function         */
        icukrell_save_config,           /* Save user config                  */
        icukrell_load_config,           /* Load user config                  */
        CONFIG_KEYWORD,                 /* config keyword                    */
        NULL,                           /* Undefined 2                       */
        NULL,                           /* Undefined 1                       */
        NULL,                           /* private                           */
        MON_MAIL,                       /* Insert plugin before this monitor */
        NULL,                           /* Handle if a plugin, filled in by GkrellM */
        NULL                            /* path if a plugin, filled in by GKrellM   */
};

Monitor *init_plugin()
{
	/* popup menu */
	running_factory = options_menu_factory(1);
	not_running_factory = options_menu_factory(0);

	g_atexit(quit_plugin_func);
	
        style_id = gkrellm_add_meter_style(&plugin_monitor, STYLE_NAME);

        return &plugin_monitor;
}
